/**
    ##############################################################################
    ##                                                                          ##
    ## EnvInfo                                                                  ##
    ##                                                                          ##
    ## Copyright (C) 2009  Frederic Roudaut  <frederic.roudaut@free.fr>         ##
    ##                                                                          ##
    ## This class is an adaption of the one done by Nicolas Richasse for his    ##
    ## Java Iperf frontend.                                                     ##
    ##                                                                          ##
    ##                                                                          ##
    ## This program is free software: you can redistribute it and/or modify     ##
    ## it under the terms of the GNU General Public License as published by     ##
    ## the Free Software Foundation, either version 3 of the License, or        ##
    ## (at your option) any later version.                                      ##
    ##                                                                          ##
    ## This program is distributed in the hope that it will be useful,          ##
    ## but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
    ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
    ## GNU General Public License for more details.                             ##
    ##                                                                          ##
    ## You should have received a copy of the GNU General Public License        ##
    ## along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
    ##                                                                          ##
    ##                                                                          ##
    ##############################################################################
 **/

   package com.envInfo;


import java.awt.BorderLayout;

import javax.swing.JPanel;

import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;


/**
 * Class used to abstract charts for the Memory charts.
 * <br/><br/>
 * This class is one of those done by Nicolas Richasse for his   
 * Java Iperf frontend.
 *
 **/
public abstract class AbstractChartPanel extends JPanel
{
	private static final long serialVersionUID = 1L;    
	
    protected JFreeChart jFreeChart;
    protected ChartPanel chartPanel;

    /**
     * Default Constructor.
     *
     **/
    public AbstractChartPanel()
    {
	init();
    }

    /**
     * Initialisation.
     *
     **/
    private void init()
    {
	// layout configuration
	this.setLayout(new BorderLayout());
    }
	
    /**
     * Lower Quality.
     *
     **/
    public void setLowQuality()
    {
	jFreeChart.getRenderingHints().clear();
    }
	
    /**
     * Get the chart Panel.
     * @return the chart Panel.
     **/
    public ChartPanel getChartPanel()
    {
	return chartPanel;
    }

    /**
     * Get JFreeChart.
     * @return JFreeChart.
     **/
    public JFreeChart getJFreeChart()
    {
	return jFreeChart;
    }
}
