/**
   ##############################################################################
   ##                                                                          ##
   ## EnvInfo                                                                  ##
   ##                                                                          ##
   ## Copyright (C) 2009  Frederic Roudaut  <frederic.roudaut@free.fr>         ##
   ##                                                                          ##
   ##                                                                          ##
   ## This program is free software: you can redistribute it and/or modify     ##
   ## it under the terms of the GNU General Public License as published by     ##
   ## the Free Software Foundation, either version 3 of the License, or        ##
   ## (at your option) any later version.                                      ##
   ##                                                                          ##
   ## This program is distributed in the hope that it will be useful,          ##
   ## but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
   ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
   ## GNU General Public License for more details.                             ##
   ##                                                                          ##
   ## You should have received a copy of the GNU General Public License        ##
   ## along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
   ##                                                                          ##
   ##                                                                          ##
   ##############################################################################
**/



package com.envInfo;  

import javax.swing.JPanel;
import javax.swing.JButton;
import java.awt.event.*;
import javax.swing.JApplet;


/**
 * A Demonstrator Applet for showing User Info, Java Info, System Info
 *
 */
public class EnvInfoApplet extends JApplet 
{
    private static final long serialVersionUID = 1L;    
  
    /**
     * Called when the applet is first loaded.
     * 
     */
    public void init ()
    {

	JPanel textPanel = new JPanel();

	JButton userInfobutton = new JButton(Info.ressources.getObject("User_Info").toString());
	userInfobutton.addActionListener(new ActionListener() {	
		public void actionPerformed(ActionEvent e) {
		    new UserInfo();
		}});	 
	textPanel.add(userInfobutton);

	JButton javaInfobutton = new JButton(Info.ressources.getObject("Java_Info").toString());
	javaInfobutton.addActionListener(new ActionListener() {	
		public void actionPerformed(ActionEvent e) {
		    new JavaInfo();
		}});	 
	textPanel.add(javaInfobutton);

	JButton systemInfobutton = new JButton(Info.ressources.getObject("System_Info").toString());
	systemInfobutton.addActionListener(new ActionListener() {	
		public void actionPerformed(ActionEvent e) {
		    new SystemInfo();
		}});	 
	textPanel.add(systemInfobutton);
	
	add(textPanel);	
    }
}