/**
   ##############################################################################
   ##                                                                          ##
   ## EnvInfo                                                                  ##
   ##                                                                          ##
   ## Copyright (C) 2009  Frederic Roudaut  <frederic.roudaut@free.fr>         ##
   ##                                                                          ##
   ##                                                                          ##
   ## This program is free software: you can redistribute it and/or modify     ##
   ## it under the terms of the GNU General Public License as published by     ##
   ## the Free Software Foundation, either version 3 of the License, or        ##
   ## (at your option) any later version.                                      ##
   ##                                                                          ##
   ## This program is distributed in the hope that it will be useful,          ##
   ## but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
   ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
   ## GNU General Public License for more details.                             ##
   ##                                                                          ##
   ## You should have received a copy of the GNU General Public License        ##
   ## along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
   ##                                                                          ##
   ##                                                                          ##
   ##############################################################################
 **/



package com.envInfo;


import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.*;
import java.awt.Insets;
import java.awt.Font;
import java.awt.Dimension;
import javax.swing.*;

import com.awt.GridBagLayoutConstraint;

import java.util.*;



/**
 * An helpful class for tierce information, for showing Java Info  
 *
 */
public class JavaInfo extends JFrame
{

	private static final long serialVersionUID = 1L;


	/**
	 * Draw a Frame with Java Info.
	 *
	 */       
	public JavaInfo()
	{
		this(new Dimension(500, 300));
	}

	/**
	 * Draw a Frame with Java Info.
	 * @param d the text Panel Dimension.
	 *
	 */       
	public JavaInfo(Dimension d)
	{
		super(Info.ressources.getObject("Java_Info").toString());	
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		setVisible(true);

		JLabel entryText;			
		JPanel textPanel = new JPanel();

		GridBagLayout gb = new GridBagLayout();
		textPanel.setLayout(gb);

		entryText = new JLabel(Info.ressources.getObject("java_specification_name").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,11,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.specification.name"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,11,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_specification_version").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,12,
				new Insets(0,8,0,15)));	

		entryText = new JLabel("= " + System.getProperty("java.specification.version"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,12,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_version").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,13,
				new Insets(0,8,0,15)));


		entryText = new JLabel("= " + System.getProperty("java.version"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,13,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_vendor").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,14,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.vendor"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,14,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_vm_version").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,15,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.vm.version"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,15,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_class_version").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,16,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.class.version"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,16,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_runtime_name").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,17,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.runtime.name"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,17,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_runtime_version").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,18,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.runtime.version"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,18,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_home").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,19,
				new Insets(0,8,0,15)));	

		entryText = new JLabel("= " + System.getProperty("java.home"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,19,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_ext_dirs").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,20,
				new Insets(0,8,0,15)));

		entryText = new JLabel("= " + System.getProperty("java.ext.dirs"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,20,
				new Insets(0,8,0,15)));		

		entryText = new JLabel(Info.ressources.getObject("java_class_path").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,21,
				new Insets(0,8,0,15)));


		entryText = new JLabel("= " + System.getProperty("java.class.path"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,21,
				new Insets(0,8,0,15)));		


		JScrollPane textScrolled = new JScrollPane(textPanel);
		textScrolled.setPreferredSize(d);	
		JPanel javaInfoBoxPanel = new JPanel(new BorderLayout());
		GridBagLayout gbMain = new GridBagLayout();
		javaInfoBoxPanel.setLayout(gbMain);
		javaInfoBoxPanel.add(textScrolled);
		GridBagConstraints gbc = new GridBagLayoutConstraint(GridBagConstraints.EAST,0,0,
				new Insets(15,15,15,15));
		gbc.gridwidth = 3;
		gbMain.setConstraints(textScrolled, gbc);

		JButton packagesbutton = new JButton("PKGs");
		javaInfoBoxPanel.add(packagesbutton);
		gbMain.setConstraints(packagesbutton, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,1,
				new Insets(8,8,8,2)));
		packagesbutton.addActionListener(new ActionListener() {	
			public void actionPerformed(ActionEvent e) {
				showJavaPackagesInfo();
			}});	 

		JButton propertiesbutton = new JButton(Info.ressources.getObject("Properties").toString());
		javaInfoBoxPanel.add(propertiesbutton);
		gbMain.setConstraints(propertiesbutton, new GridBagLayoutConstraint(GridBagConstraints.EAST,1,1,
				new Insets(8,2,8,8)));
		propertiesbutton.addActionListener(new ActionListener() {	
			public void actionPerformed(ActionEvent e) {
				showJavaPropertiesInfo();
			}});	 



		JButton okbutton = new JButton(Info.ressources.getObject("OK").toString());
		javaInfoBoxPanel.add(okbutton);
		gbMain.setConstraints(okbutton, new GridBagLayoutConstraint(GridBagConstraints.EAST,2,1,
				new Insets(8,8,8,8)));
		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
				dispose();
			}
		});	 

		getContentPane().add(javaInfoBoxPanel, BorderLayout.CENTER);		
		pack();
		setResizable(false);
		setVisible(true);
	}



	/**
	 * Draw a Frame with the Java Packages Info.
	 *
	 */      
	public static void showJavaPackagesInfo()
	{
		showJavaPackagesInfo(new Dimension(650, 800));
	}

	/**
	 * Draw a Frame with the Java Packages Info.
	 * @param d the text Panel Dimension
	 *
	 */      
	public static void showJavaPackagesInfo(Dimension d)
	{
		final JFrame pkgsFrame = new JFrame(Info.ressources.getObject("Packages_Info").toString());
		pkgsFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);	

		JTextArea text = new JTextArea();
		text.setFont(new Font("SansSerif", Font.PLAIN, 12));       
		JPanel textPanel = new JPanel();
		JPanel pkgsPanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();
		pkgsPanel.setLayout(gb);

		Package pkgs[];
		pkgs = Package.getPackages();		
		JScrollPane textScrolled = new JScrollPane(text);	
		textScrolled.setPreferredSize(d);   
		textPanel.add(textScrolled);	
		pkgsPanel.add(textPanel);
		gb.setConstraints(textPanel, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,0,
				new Insets(15,15,15,15)));

		String [] pkgsTab = new String [pkgs.length];
		String textContent = "";

		for(int i=0; i < pkgs.length; i++)
		{			    
			pkgsTab[i] = " " + pkgs[i].getName() + " : " +
			pkgs[i].getImplementationTitle() + ", " +
			pkgs[i].getImplementationVendor() + ", " +
			pkgs[i].getImplementationVersion() + "\n";		    
		}
		Arrays.sort(pkgsTab);
		for(int i=0; i < pkgs.length; i++)
		{
			textContent += pkgsTab[i];
		}

		text.append(textContent);
		text.setCaretPosition(0);

		JButton okbutton = new JButton(Info.ressources.getObject("OK").toString());
		pkgsPanel.add(okbutton);
		gb.setConstraints(okbutton, new GridBagLayoutConstraint(GridBagConstraints.EAST,0,1,
				new Insets(15,8,8,8)));
		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				pkgsFrame.setVisible(false);
				pkgsFrame.dispose();
			}
		});

		pkgsFrame.getContentPane().add(pkgsPanel);		
		pkgsFrame.setResizable(false);
		pkgsFrame.pack();
		pkgsFrame.setVisible(true);

	}


	/**
	 * Draw a Frame with all the Java Properties Info.
	 *
	 */      
	public static void showJavaPropertiesInfo()
	{
		showJavaPropertiesInfo(new Dimension(650, 800));
	}

	/**
	 * Draw a Frame with all the Java Properties Info.
	 * @param d the text Panel Dimension.
	 *
	 */      
	public static void showJavaPropertiesInfo(Dimension d)
	{
		final JFrame propertiesFrame = new JFrame(Info.ressources.getObject("System_Properties_Info").toString());	
		propertiesFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);	

		JTextArea text = new JTextArea();
		text.setFont(new Font("Courier", Font.PLAIN, 12));       
		JPanel textPanel = new JPanel();
		JPanel propertiesPanel = new JPanel();
		GridBagLayout gb = new GridBagLayout();
		propertiesPanel.setLayout(gb);

		Properties properties = System.getProperties();

		JScrollPane textScrolled = new JScrollPane(text);	
		textScrolled.setPreferredSize(d);   
		textPanel.add(textScrolled);	
		propertiesPanel.add(textPanel);
		gb.setConstraints(textPanel, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,0,
				new Insets(15,15,15,15)));

		String textContent = "";
		Vector propertiesTab = new Vector();
		for (Enumeration e = properties.propertyNames() ; e.hasMoreElements() ;) 
		{	
			propertiesTab.addElement(e.nextElement());
		}	

		Collections.sort(propertiesTab);
		String blkString = "                         ";
		blkString += blkString;
		for(int i=0; i < propertiesTab.size(); i++)
		{
			if(((String)propertiesTab.get(i)).length() < blkString.length())
				textContent += " " + ((String)propertiesTab.get(i)).trim() 
				+ blkString.substring(((String)propertiesTab.get(i)).length()) 
				+ "= " + System.getProperty((String)propertiesTab.get(i)) 
				+ "\n";		
			else textContent += ((String)propertiesTab.get(i)).trim() 			 
			+ "= " + System.getProperty((String)propertiesTab.get(i)) 
			+ "\n";				    
		}	

		text.append(textContent);
		text.setCaretPosition(0);

		JButton okbutton = new JButton(Info.ressources.getObject("OK").toString());
		propertiesPanel.add(okbutton);
		gb.setConstraints(okbutton, new GridBagLayoutConstraint(GridBagConstraints.EAST,0,1,
				new Insets(15,8,8,8)));
		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				propertiesFrame.setVisible(false);
				propertiesFrame.dispose();
			}
		});

		propertiesFrame.getContentPane().add(propertiesPanel);		
		propertiesFrame.setResizable(false);
		propertiesFrame.pack();
		propertiesFrame.setVisible(true);

	}




}