/**
   ##############################################################################
   ##                                                                          ##
   ## EnvInfo                                                                  ##
   ##                                                                          ##
   ## Copyright (C) 2009  Frederic Roudaut  <frederic.roudaut@free.fr>         ##
   ##                                                                          ##
   ## This class is an adaption of the one done by Nicolas Richasse for his    ##
   ## Java Iperf frontend.                                                     ##
   ##                                                                          ##
   ##                                                                          ##
   ## This program is free software: you can redistribute it and/or modify     ##
   ## it under the terms of the GNU General Public License as published by     ##
   ## the Free Software Foundation, either version 3 of the License, or        ##
   ## (at your option) any later version.                                      ##
   ##                                                                          ##
   ## This program is distributed in the hope that it will be useful,          ##
   ## but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
   ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
   ## GNU General Public License for more details.                             ##
   ##                                                                          ##
   ## You should have received a copy of the GNU General Public License        ##
   ## along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
   ##                                                                          ##
   ##                                                                          ##
   ##############################################################################
**/

package com.envInfo;

import java.awt.Color;

/**
 * Class used to generate colors for the Memory charts.
 * <br/><br/>
 * This class is an adaption of the one done by Nicolas Richasse for his   
 * Java Iperf frontend.
 *
 **/
public class SeriesColorGenerator 
{
    private static Color[] allColors = 
    { Color.green, Color.red, Color.yellow, Color.blue, Color.gray, Color.magenta, Color.white, Color.orange, Color.cyan, Color.darkGray, Color.lightGray, Color.pink};
    private static int currentIndex = 0;
	
    /**
     * Return a new Color.
     * @return a new Color.
     *
     */
    public static Color nextColor()
    {
	Color res = allColors[currentIndex];
	currentIndex = (currentIndex+1)%allColors.length;
	return res;
    }
	
    /**
     * Reset all the colors choice.
     *
     */
    public static void reset()
    {
	currentIndex = 0;
    }
}
