/**
   ##############################################################################
   ##                                                                          ##
   ## EnvInfo                                                                  ##
   ##                                                                          ##
   ## Copyright (C) 2009  Frederic Roudaut  <frederic.roudaut@free.fr>         ##
   ##                                                                          ##
   ##                                                                          ##
   ## This program is free software: you can redistribute it and/or modify     ##
   ## it under the terms of the GNU General Public License as published by     ##
   ## the Free Software Foundation, either version 3 of the License, or        ##
   ## (at your option) any later version.                                      ##
   ##                                                                          ##
   ## This program is distributed in the hope that it will be useful,          ##
   ## but WITHOUT ANY WARRANTY; without even the implied warranty of           ##
   ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            ##
   ## GNU General Public License for more details.                             ##
   ##                                                                          ##
   ## You should have received a copy of the GNU General Public License        ##
   ## along with this program.  If not, see <http://www.gnu.org/licenses/>.    ##
   ##                                                                          ##
   ##                                                                          ##
   ##############################################################################
 **/



package com.envInfo;


import java.awt.BorderLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.*;
import java.awt.Insets;
import java.awt.Font;
import java.awt.Dimension;
import javax.swing.*;

import com.awt.GridBagLayoutConstraint;



/**
 * An helpful class for tierce information, for showing User Info ...
 *
 */
public class UserInfo extends JFrame
{

	private static final long serialVersionUID = 1L;

	/**
	 * Draw a Frame with some useful information on User Characteristics.
	 *
	 */   
	public UserInfo() {
		this(new Dimension(500, 300));
	}

	/**
	 * Draw a Frame with some useful information on User Characteristics.
	 * @param d the text Panel Dimension.
	 *
	 */   
	public UserInfo(Dimension d) {
		super(Info.ressources.getObject("User_Info").toString());

		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);	
		setVisible(true);

		JPanel showUserPanel = new JPanel(new BorderLayout());	
		JLabel entryText;

		JPanel textPanel = new JPanel();	
		GridBagLayout gb = new GridBagLayout();
		textPanel.setLayout(gb);

		entryText = new JLabel(Info.ressources.getObject("user_name").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,0,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.name"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,0,
				new Insets(0,8,0,15)));

		entryText = new JLabel(Info.ressources.getObject("user_home").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,1,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.home"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,1,
				new Insets(0,8,0,15)));

		entryText = new JLabel(Info.ressources.getObject("user_dir").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,2,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.dir"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,2,
				new Insets(0,8,0,15)));

		entryText = new JLabel(Info.ressources.getObject("user_country").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,3,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.country"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,3,
				new Insets(0,8,0,15)));

		entryText = new JLabel(Info.ressources.getObject("user_language").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,4,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.language"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,4,
				new Insets(0,8,0,15)));

		entryText = new JLabel(Info.ressources.getObject("user_timezone").toString());
		entryText.setFont(new Font("SansSerif", Font.BOLD, 11));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,0,5,
				new Insets(0,15,0,15)));

		entryText = new JLabel("= " + System.getProperty("user.timezone"));
		entryText.setFont(new Font("SansSerif", Font.PLAIN, 10));
		textPanel.add(entryText);
		gb.setConstraints(entryText, new GridBagLayoutConstraint(GridBagConstraints.WEST,1,5,
				new Insets(0,8,0,15)));

		JScrollPane textScrolled = new JScrollPane(textPanel);	
		textScrolled.setPreferredSize(d);	

		showUserPanel.add(textScrolled, BorderLayout.WEST);
		GridBagLayout gbMain = new GridBagLayout();
		showUserPanel.setLayout(gbMain);
		showUserPanel.add(textScrolled);
		GridBagConstraints gbc = new GridBagLayoutConstraint(GridBagConstraints.EAST,0,0,
				new Insets(15,15,15,15));
		gbc.gridwidth = 2;
		gbMain.setConstraints(textScrolled, gbc);

		JButton okbutton = new JButton(Info.ressources.getObject("OK").toString());
		showUserPanel.add(okbutton);
		gbMain.setConstraints(okbutton, new GridBagLayoutConstraint(GridBagConstraints.EAST,1,1,
				new Insets(8,8,8,8)));
		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
				dispose();
			}
		});

		getContentPane().add(showUserPanel, BorderLayout.CENTER);	
		pack();
		setResizable(false);
		setVisible(true);
	}

}